package pkg01022022;
import java.util.Scanner;
public class Lista 
{
    Cittadino lista[]; // array di oggetti (non di valori)
    private int dim; // dimensione della lista
    public Lista(int n)
    {
        dim = n;
        lista = new Cittadino[dim];
    }
    public void inserimento()
    {
        Scanner s = new Scanner(System.in);
        for(int i = 0; i < dim; i++)
        {
            System.out.println("inserisci nome");
            String nome=s.next();
            System.out.println("inserisci cognome");
            String cognome=s.next();
            System.out.println("inserisci cittadinanza");
            String citt=s.next();
            System.out.println("inserisci codice fiscale");         
            String codiceFiscale=s.next();          
            System.out.println("1.Cittadino -2.Diplomatico");
            int scelta=s.nextInt();
            if(scelta==2)
            {
                System.out.println("Inserisci anno");          
                int anno=s.nextInt();
                lista[i]=new Diplomatico(nome, cognome, citt, codiceFiscale, anno);
            }
            else
                lista[i]=new Cittadino(nome, cognome, citt, codiceFiscale);
        }
                
    }
    public void stampa() 
    {
        if(dim==0)System.out.println("la lista è vuota!!!");
        else for(int i=0;i<dim;i++) System.out.println("\n" + (i+1) + ")" + lista[i].toString());   
    }
    public void diplomatcoPiuVecchio ()
    { // controlliamo che ci sia almeno un diplomaico
        if ((dim==0) ||((Diplomatico) lista[0]) == null) System.out.println("Errore !!!\n non hai diplomatici !!!!");
        else
        {
            Diplomatico min = (Diplomatico) lista[0];
            for(int i=1;i<dim;i++)
            {
                if(lista[i] instanceof Diplomatico)
                    if ( ((Diplomatico)lista[i]).getAnno() < min.getAnno() ) min=(Diplomatico)lista[i];
            }
            System.out.println("il diplomatico più vecchio è "+min.toString()+"\n");
        }
    }
    public void cittadinanzaUguale ()
    {
        if (dim>0)
        { 
            String c =lista[0].getCittadinanza(); 
            int contatore=0;  
            for(int i=1;i<dim;i++) if (lista[i] instanceof Cittadino && lista[i].getCittadinanza().equals(c)) contatore++; 
            System.out.println("Trovate " + contatore +" corrispondenze");
        }
    }

    public int getDim() { return dim; }

    public void setDim(int dim) { this.dim = dim;}
    
    
    public void CambiaMestiere()
    {
        Scanner s = new Scanner(System.in);
        int scelta = 0, modifica;
        do
        {
            
            System.out.println("\n1) Cambio da Cittadino a Diplomatico");
            System.out.println ("2) Cambio da Diplomatico a Cittadino");
            System.out.println("0) Annulla");
            System.out.print("  Scelta -> ");
            scelta = s.nextInt();
            stampa();
            System.out.print("\nInserisci il Cittadino da far diventare Diplomatico o viceversa: ");
            modifica = s.nextInt();
            switch (scelta) 
            {
                case 1:
                    int anno;
                    System.out.print("Inserisci data di servizio del Cittadino: ");
                    anno = s.nextInt();
                    if (lista[modifica-1] instanceof Cittadino)
                        lista[modifica-1] = new Diplomatico(lista[modifica-1].getNome(), lista[modifica-1].getCognome(), lista[modifica-1].getCittadinanza(), lista[modifica-1].getCodiceFiscale(), anno);
                    else System.out.println("Già è un cittadino");
                    break;
                case 2:
                    if(lista[modifica-1] instanceof Diplomatico)
                        lista[modifica-1] = new Cittadino(lista[modifica-1].getNome(), lista[modifica-1].getCognome(), lista[modifica-1].getCittadinanza(), lista[modifica-1].getCodiceFiscale());  
                    else System.out.println("Già è un diplomatico");
                    break;
            }
        }while(scelta != 0);
    }
}
