/*
Definite la classe Cittadino
i cui oggetti rappresentano cittadini. 
Ogni cittadino è caratterizzato da nome,cognome,cittadinanza, codiceFiscale, parametri di tipo String
La classe deve avere:   l’ovvio costruttore con 4 argomenti;
un costruttore con 3 argomenti in cui si assume che la cittadinanza sia “Italia”
(la cittadinanza viene espressa tramite lo stato di appartenenza);
i metodi getNome , getCognome ,getCitt,getCF dall’ovvio significato;
il metodo setCitt che assegna all’oggetto che lo invoca la cittadidanza passata come argomento;
i metodi toString e equals dall’ovvio significato (attenzione alla costruzione del metodo equals !).
La classe Cittadino va inoltre estesa da una classe Diplomatico i cui oggetti rappresentano
appartenenti a corpi diplomatici. Oltre ai parametri che caratterizzano un cittadino, un
diplomatico deve possedere l’anno (tipo int) in cui ha preso servizio presso il corpo di appartenenza.
La classe Diplomatico, oltre ovviamente al costruttore, deve anche avere:
i metodi toString, equals, getAnno dall’ovvio significato;
un metodo public boolean piuVecchio( Diplomatico d )
che restituisce true se la presa di servizio del diplomatico che invoca il metodo è
anteriore a quella del diplomatico passato come argomento, false altrimenti.
*/
package pkg01022022;
import java.util.Scanner;
public class Main {
    public static void main(String[] args) {
    Scanner s = new Scanner(System.in);
    Lista l;
    System.out.println("Inserisci dimensione: ");
    int n = s.nextInt(), vecchiaDim;
    l = new Lista(n);
    int scelta; // serve per il menu'
        do {
            System.out.println("0) Cambia dimensione");
            System.out.println("1) Inserisci Elementi");
            System.out.println("2) Cerca diplomatico più anziano");
            System.out.println("3) Cerca cittadinanze uguali");
            System.out.println("4) Stampa Elementi");
            System.out.println("5) Cambia dati");
            System.out.println("6) Cambia Cittadino in Diplomatico e viceversa");
            System.out.println("9) Uscita\n\n");
            System.out.print("  Scelta ->");
            scelta = s.nextInt();
            switch (scelta) 
            {
                case 0:
                    System.out.print("\nInserisci nuova dimensione: ");
                    n = s.nextInt();
                    l.setDim(n);
                    break;
                case 1:
                    if(n != 0)
                    {
                        l.inserimento();
                        break;
                    } else {
                        System.out.println("Non puoi inserire cittadini se la dimensione è 0");
                        break;
                    }
                case 2:
                    l.diplomatcoPiuVecchio();
                    break;
                case 3:    
                    l.cittadinanzaUguale();
                    break;
                case 4:    
                    l.stampa();
                    break; 
                case 5:
                    if (n != 0)
                    {
                        int modifica = 0, cambia;
                        l.stampa();
                        System.out.print("\nInserisci il cittadino che vuoi modificare: ");
                        modifica = s.nextInt();
                        do
                        {
                            System.out.println("\n1) Cambia nome");
                            System.out.println("2) Cambia cognome");
                            System.out.println("3) Cambia cittadinanza");
                            System.out.println("4) Cambia C.Fiscale");
                            System.out.println("0) Annulla\n\n");
                            System.out.print("  Scelta ->");
                            cambia = s.nextInt();
                            if(modifica != 0)
                            {
                                switch(cambia)
                                    {
                                        case 1:
                                            String nome;
                                            System.out.println("\nVecchio nome: " + l.lista[modifica-1].getNome());
                                            System.out.print("\nNuovo nome: ");
                                            nome = s.nextLine();
                                            nome = s.nextLine();
                                            l.lista[modifica-1].setNome(nome);
                                            break;
                                        case 2:
                                            String cognome;
                                            System.out.println("Vecchio cognome: " + l.lista[modifica-1].getCognome());
                                            System.out.print("\nNuovo cognome: ");
                                            cognome = s.nextLine();
                                            cognome = s.nextLine();
                                            l.lista[modifica-1].setCognome(cognome);
                                            break;
                                        case 3:
                                            String citt;
                                            System.out.println("Vecchia cittadinanza: " + l.lista[modifica-1].getCittadinanza());
                                            System.out.print("\nNuova cittadinanza: ");
                                            citt = s.nextLine();
                                            citt = s.nextLine();
                                            l.lista[modifica-1].setCittadinanza(citt);
                                            break;
                                        case 4:
                                            String codFis;
                                            System.out.println("Vecchio C.Fiscale: " + l.lista[modifica-1].getCodiceFiscale());
                                            System.out.print("\nNuovo C.Fiscale: ");
                                            codFis = s.nextLine();
                                            codFis = s.nextLine();
                                            l.lista[modifica-1].setCodiceFiscale(codFis);
                                            break;
                                    }
                            } else System.out.println("Devi inserire un cittadino!!!");
                        }while(cambia != 0);
                    }else System.out.println("La lista è vuota!!!");
                    break;
                case 6:
                    if(n != 0)
                        l.CambiaMestiere();
                    else System.out.println("La lista è vuota!!!");
            }     
        }while (scelta != 9);
    }
}
